PROBLEM LINK:Author: Roman Rubanenko DIFFICULTY:MEDIUM PREREQUISITES:PROBLEM:The best described in the problem statement. QUICK EXPLANATION:It is clear that we have a complete weighted graph where vertices are the points and weight of the edge is the square of the distance between points. The problem asks to find the cyclefree set of edges with maximal product of weights. At first sight it seems to be the maximum spanning tree in this graph. But since some edges can have zero weights we actually should maximize the product of nonzero edges in our spanning tree. Since graph is complete then naive implementation of Prim's algorithm would be the simplest way here. Note that Prim's algorithm works in O(V * V) time while Kruskal algorithm in O(E * log E) time, where V is the number of vertexes in the graph and E is the number of edges. In our case the graph is complete, so E = V * (V − 1) / 2 and hence Kruskal algorithm is much slower (due to log E factor). It was intended that Kruskal should get TLE, while any implementation of Prim (with precalculating all edges or not) will get AC. The main bottleneck of the Kruskal algorithm is sorting of edges (not DSU stuff) and in the Prim we have no sorting at all. That is the point. EXPLANATION:As noted above we can reformulate the problem as follows  find the spanning tree in constructed graph that has maximum possible product of nonzero edges in it. It is wellknown that spanning tree found by general greedy algorithm (like Prim's or Kruskal's) will maximize any symmetric monotone function of edges (I read this remark 10 years ago in Christofides book and still remember this). The product of nonzero edges is exactly one of such functions since we have no negative edges. Hence wellknown algorithms for finding maximum spanning tree will work here. The implementation of Prim's algorithm suited for this problem is provided below. Once maximum distance between marked and not marked vertexes becomes zero we could break from the cycle. Also we do not create the adjacency matrix and calculate each needed distance on the fly. And the most important thing is  the squares of distances should be calculated and compared as is, take them modulo 747474747 only when you multiply them to the answer. For example, if we have only two points, and square of distance between them is 747474747 then in the case of taking this distance modulo at the beginning you break from the cycle and the answer will be 1, but the correct answer is 747474747 and you should output 0. The concrete example is
The output should 0. And finally the code snippet:
AUTHOR'S AND TESTER'S SOLUTIONS:Author's solution will be provided soon. RELATED PROBLEMS:
This question is marked "community wiki".
asked 15 Apr '13, 15:00

Similar Problem: answered 15 Apr '13, 21:34

Me too used Kruskal's algorithm with rankedunion, path compression, everything!! Only to find later that the sorting of edges is taking too much time :( (The complete solution took ~24 seconds for a large test case, on my local machine.) Link to Solution: http://www.codechef.com/viewplaintext/2045584 PS: Never thought Prim's algorithm can do the trick!! answered 15 Apr '13, 17:07
@tijoforyou same here calculaton of distances and sorting of edges took all the time I was also getting TLE due to the same reason :(
(15 Apr '13, 17:49)

can you plz provide me a case where my solution fails, http://www.codechef.com/viewsolution/2052988 answered 15 Apr '13, 15:35
2
1
(17 Apr '13, 12:56)
thnx a lot :)
(17 Apr '13, 17:52)

@anton_lunyov I tried with kruskal and got TLE in edge distance calculation and sorting. I thought of prim's algorithm too but don't you think all the edge distances will have to be calculated in prim's too? :o ... I was getting TLE because for kruskal I calculated distance between every pair of vertices and then sorted according to the distance. Please clear my doubts. and pleasse refer to my solution and if possible tell me the bad places because of which i got TLE. Thanks in advance answered 15 Apr '13, 18:03
@amitupadhyay the problem is not with filling of the graph (n(n1)/2 edges). But with the sorting of edges also some over head due to unionfind. I have precalculated all the distance (V^2) than applied prim's.
(15 Apr '13, 19:15)
@nirajs got it :( my bad. thanks btw:)
(15 Apr '13, 19:22)

Isn't time complexity for Prims and Kruskals same : O(ElogV) where E = V^2 for complete graph. It may be the case that prims is faster than kruskals because it doesn't require all the edges to be sorted before hand, right? answered 15 Apr '13, 20:06
according to wikipedia, Prim's complexity is O(V^2)  http://en.wikipedia.org/wiki/Prim's_algorithm#Time_complexity
(15 Apr '13, 20:36)
@betlista : Using binary heap Prim's complexity can be brought down to O(ElogV)
(16 Apr '13, 12:46)
I saw that on wikipedia, but when E=V^2, is this better? I don't think so, or I missed something?
(16 Apr '13, 13:28)

Can delaunay triangulation be used here to bring down the complexity to O(VlogV)??? answered 16 Apr '13, 01:28
AFAIK O(V * log V) solution exists only in the case of plane (D = 2).
(16 Apr '13, 01:41)
The delaunay triangulation cannot be used for dimensions greater than 3 . And for the higher dimensions the research is still on. Check this wiki page for more information http://en.wikipedia.org/wiki/Delaunay_triangulation#section_2
(16 Apr '13, 13:23)

Hi programmers, I tried to implement Prim's algorithm, but I'm getting WA. I compared the results with my previous Kruskal implementation and I'm getting same result. Is there some corner case, that's not covered by my random tests (or any other bug)? My submission is here  http://www.codechef.com/viewsolution/2056473 Thanks answered 17 Apr '13, 11:14
1
You should take distance modulo only before you multiply it to the answer. Refer to my code snippet in editorial (I've changed it a bit to explain this bug).
(17 Apr '13, 12:41)
Thank you very much that was the problem. Probably I have same bug in my Kruskal implementation so I didn't find it.
(17 Apr '13, 13:10)

can anyone explain NZEC ? answered 17 Apr '13, 11:21

Hello @all, I have tried to implement Prim's Algorithm...but I am getting TLE,I have used a stl::priority queue for the finding the min distance...could you all have a look into my program and tell me where my program is getting slow. ideone link: http://www.codechef.com/viewsolution/2038046 Thanks in advance. answered 18 Apr '13, 17:45
Complexity of your solution is O(N^2 * log N).
(18 Apr '13, 21:13)
Firstly thanks for the reply,secondly could you please explain me how did you come up with that complexity...actually I thought that my complexity is O(N*log N)..considering the log N was the insertion time in the priority queue..Thanks in advance again...:)
(18 Apr '13, 21:46)
1
At each step of algorithm (N1 times) for each unvisited vertex you push pair (u, j) to the heap.
(18 Apr '13, 21:49)
Thanks a lot...will keep in mind next time.
(19 Apr '13, 00:09)

can anyone tell where this code fails i have tried many test cases it is giving correct answer but still getting wa on the judge my submission id is : http://www.codechef.com/viewsolution/2060320 answered 20 Apr '13, 16:37
(20 Apr '13, 16:55)
thank you very very much for your help i made the changes and it worked.......got ac after 10 wa
(20 Apr '13, 17:07)
Congrats!
(20 Apr '13, 17:10)
can you explain how the complexity comes out to be O(N^2 * log N) .as in the while loop i build the heap which is o(n)and this loop will occur n times so overall complexity should be O(n^2)
(20 Apr '13, 17:19)
Your solution is quite unclear. But it seems to me that
(20 Apr '13, 17:23)

Well I also can't get it right. I always get wrong answer. Could anyone help me? :)
link
This answer is marked "community wiki".
answered 20 Apr '13, 19:26
1
When
(20 Apr '13, 22:01)
Well of course :D Thanks Anton!
(20 Apr '13, 22:13)

Hey I have tried implementing the same solution as mentioned in the editorial  http://www.codechef.com/viewsolution/2170014 I am getting WA. Can anyone point out the mistake in this solution? Thanks. answered 19 May '13, 22:19

I had a doubt regarding the time complexity of Prim's algorithm. Isn't Prim without a heap and using adjacency list O(V*E) because the outer loop is O(V) and the inner that computes the greedy minimum values O(E).Won't the simple implementation give TLE in this case? answered 12 Jun '13, 19:40

Getting WA.But am not able to work out any corner cases.Can somebody give me some test cases.Help? answered 23 Jun '13, 01:15

What happen when 2 towns are in 1 same points? should it output 0/1, as i tested in your program it gave 1, but shouldn't it 0 because we need to connect those two town with distance of 0? answered 30 Jan, 16:17

I know that won't be a big improvement, but we can use
I've also noticed this but decided to stay on "d[j] = 0" version.
But now I see that your version is better since if distances are allowed to be between 0 and 1 then your version is correct but mine not :)
So I've changed the code snippet.
But in this problem d[j] cannot be in interval (0;1), points have integer coordinates. Btw: comparison is wrong
>=
instead of<=
.Thanks, fixed. If double would be allowed than distance could be any positive real number and only your version is correct since multiplying the answer by number less than 1 will decrease it.
Fun fact, modulo 747474747 is not a prime number :)